# condor commands
# Set the accounting tag from https://ldas-gridmon.ligo.caltech.edu/ldg_accounting/user
ACCOUNTING_TAG=ligo.dev.o2.cbc.bbh.gstlaloffline
GROUP_USER=duncan.meacher
CONDOR_COMMANDS:=--condor-command=accounting_group=$(ACCOUNTING_TAG) --condor-command=accounting_group_user=$(GROUP_USER)

#########################
# Triggering parameters #
#########################

# The detectors to analyze
IFOS = H1 L1
# The GPS start time for analysis (O1)
START = 1126051217
# The GPS end time for analysis (O1, start + 100000s)
STOP = 1127271617
# A user tag for the run
TAG = test_dag
# Run number
RUN = run1
# A web directory for output
WEBDIR = /home/gstlalcbc/public_html/testing/ER10/O1_chunk1_injection_run1_161208
# The number of sub banks to process in parallel for each gstlal_inspiral job
NUMBANKS = 5
# The control peak time for the composite detection statistic.  If set to 0 the
# statistic is disabled
PEAK = 0
# The length of autocorrelation chi-squared in sample points
AC_LENGTH = 351
# The minimum number of samples to include in a given time slice
SAMPLES_MIN = 2048
# The maximum number of samples to include in the 256 Hz or above time slices
SAMPLES_MAX_256 = 2048
# Low frequency cut off for the template bank placement
LOW_FREQUENCY_CUTOFF = 15.0

#############################
# additional options, e.g., #
#############################

ADDITIONAL_DAG_OPTIONS:=--samples-min $(SAMPLES_MIN) --samples-max-256 $(SAMPLES_MAX_256)

##############
# Injections #
##############

# The seed is the string before the suffix _injections.xml
# Change as appropriate, whitespace is important
MCHIRP_INJECTIONS := 0.57:15.70:split_injections_0000.xml

# The Channel names. FIXME sadly you have to change the CHANNEL_NAMES string if
# you want to analyze a different set of IFOS
H1_CHANNEL=DCS-CALIB_STRAIN_C02
L1_CHANNEL=DCS-CALIB_STRAIN_C02
CHANNEL_NAMES:=--channel-name=H1=$(H1_CHANNEL) --channel-name=L1=$(L1_CHANNEL)

# Set to original run directory and and zero lag database.
# Zero lag run
ZERO_LAG_DIR:=/work/gstlalcbc/engineering/10/offline/O1-chunk1_run1_O2_test_161122
ZERO_LAG_DB:=$(ZERO_LAG_DIR)/H1L1-ALL_LLOID-1126051217-1220400.sqlite

# These shouldn't need to be changed.
REF_PSD:=$(ZERO_LAG_DIR)/reference_psd.cache
SEGMENTS:=$(ZERO_LAG_DIR)/segments.xml.gz
VETOES:=$(ZERO_LAG_DIR)/vetoes.xml.gz
FRAME_CACHE:=$(ZERO_LAG_DIR)/frame.cache
TISI:=$(ZERO_LAG_DIR)/tisi.xml
TISI_INJ:=$(ZERO_LAG_DIR)/inj_tisi.xml
MARG:=$(ZERO_LAG_DIR)/marginalized_likelihood.xml.gz
MARG_ZL:=$(ZERO_LAG_DIR)/marginalized_likelihood_with_zerolag.xml.gz
POSTMARG:=$(ZERO_LAG_DIR)/post_marginalized_likelihood.xml.gz
REF_LIKELIHOOD:=$(ZERO_LAG_DIR)/reference_likelihood_file.xml.gz

WORK_DIR:=$(PWD)

#
# Get some basic definitions.  NOTE this comes from the share directory probably.
#

include $(HOME)/local/src/gstlal/gstlal-inspiral/share/Makefile.offline_analysis_rules

#
# Workflow
#

all : dag

dag : svd_bank.cache dist_stats.cache $(REF_PSD) $(ZERO_LAG_DB) $(SEGMENTS) $(VETOES) $(FRAME_CACHE) $(TISI) $(TISI_INJ) plots $(WEBDIR) $(INJECTIONS) $(MARG) $(MARG_LZ) $(POSTMARG) $(REF_LIKELIHOOD)
	cp $(MARG) .
	cp $(POSTMARG) .
	cp $(REF_LIKELIHOOD) .
	cp $(MARG_ZL) .
	cp $(REF_PSD) .
	gstlal_inspiral_pipe \
		--data-source frames \
		--gps-start-time $(START) \
		--gps-end-time $(STOP) \
		--frame-cache $(FRAME_CACHE) \
		--frame-segments-file $(SEGMENTS) \
		--vetoes $(VETOES) \
		--frame-segments-name datasegments  \
		--control-peak-time $(PEAK) \
		--fir-stride 1 \
		--web-dir $(WEBDIR) \
		--time-slide-file $(TISI) \
		--inj-time-slide-file $(TISI_INJ) \
		$(INJECTION_LIST) \
		$(CHANNEL_NAMES) \
		--ht-gate-threshold-linear 0.8:12.0-45.0:100.0 \
		$(CONDOR_COMMANDS) \
		--singles-threshold 100.0 \
		--tolerance 0.9999 \
		--flow $(LOW_FREQUENCY_CUTOFF) \
		--autocorrelation-length $(AC_LENGTH) \
		--svd-bank-cache svd_bank.cache \
		--dist-stats-cache dist_stats.cache \
		--non-injection-db $(ZERO_LAG_DB) \
		--psd-cache reference_psd.cache \
		--marginalized-likelihood-file marginalized_likelihood.xml.gz \
		--marginalized-likelihood-with-zerolag-file marginalized_likelihood_with_zerolag.xml.gz \
		--reference-likelihood-file reference_likelihood_file.xml.gz \
		--request-cpu 4 \
		--request-memory 7GB \
		--min-log-L -50.0 \
		--min-instruments 1 \
		$(ADDITIONAL_DAG_OPTIONS)
	sed -i '1s/^/JOBSTATE_LOG logs\/trigger_pipe.jobstate.log\n/' trigger_pipe.dag

$(WEBDIR) : $(MAKEFILE_LIST)
	mkdir -p $(WEBDIR)/OPEN-BOX

plots :
	mkdir plots

dist_stats.cache :
	cd $(ZERO_LAG_DIR)/gstlal_inspiral_marginalize_likelihood && ls | grep "MARG_DIST_STATS" | lalapps_path2cache | sort > $(WORK_DIR)/dist_stats.cache

svd_bank.cache :
	cd $(ZERO_LAG_DIR)/gstlal_svd_bank && ls | grep "SVD" | lalapps_path2cache | sort > $(WORK_DIR)/svd_bank.cache

clean :
	-rm -rvf *.sub *.dag* *.cache *.sh logs *.sqlite plots *.html Images *.css *.js
	-rm -rvf lalapps_run_sqlite/ ligolw_* gstlal_*
	-rm -vf segments.xml.gz tisi.xml H1-*.xml H1_*.xml L1-*.xml L1_*xml V1-*.xml V1_*xml ?_injections.xml ????-*_split_bank-*.xml vetoes.xml.gz
	-rm -vf *marginalized*.xml.gz *-ALL_LLOID*.xml.gz
	-rm -vf tisi0.xml tisi1.xml
	-rm -rf *_split_bank*
	-rm -rf nogaps.xml segdb.xml
	-rm -rf bank_aligned_spin.xml.gz
